!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2005, 2006. All rights reserved.
!---------------------------------------------------------------------
!= Module ChemCalc
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: chemcalc.f90,v 1.4 2006/07/03 03:51:45 sugiyama Exp $
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview
!
!شϢν̤׻뤿Υ⥸塼. 
!
!Antoine ˰¾Ѥưʲ. 
!  * ˰¾
!  * ˰¾βʬ
!  * Ǯ
! 
!== Error Handling
!
!== Bugs
!
!== Note
!
!== Future Plans
!
!

module ChemCalc
  !
  !شϢν̤׻뤿Υ⥸塼. 
  !

  !⥸塼ƤӽФ
  use ChemData, only: ChemData_SpcNum,             & !ǡ١βؼ
    &                 ChemData_MolWt,              & !ʬ
    &                 ChemData_SvapPress_AntoineA, & !Antoine  A 
    &                 ChemData_SvapPress_AntoineB, & !Antoine  B 
    &                 ChemData_SvapPress_AntoineC, & !Antoine  C 
    &                 ChemData_SvapPress_AntoineUnit !ñѴѷ
  
  !ۤηػ
  implicit none

  !ΤФ private °դ. 
  private
  
  !Τˤ public °դ
  public ChemCalc_Init                            !롼
  public ChemCalcSpc_Init, ChemCalcDim_Init       !롼
  public CheckSvapPress                           !˰¾å롼
  public MolWt                                    !ʬ
  public GasR                                     !
  public Phase                                    !
  public ChemPotRef, ChemPot, ChemPotNH4SH  
                                                  !إݥƥ󥷥
  public EntropyRef, Entropy, EntropyNH4SH  
                                                  !إݥƥ󥷥
  public CpPerMassRef, CpPerMolRef, CvPerMassRef  !갵Ǯ, Ǯ
  public xz_SvapPress, SvapPress
                                                  !˰¾ [Pa]
  public SvapPressAMP
                                                  !˰¾ [Pa]
  public xz_DSvapPressDTemp, DSvapPressDTemp 
                                                  !˰¾βʬ [Pa/K]
  public xz_LatentHeatPerMass, LatentHeatPerMass
                                                  !Ǯ [J/K kg]
  public LatentHeatPerMassAMP
                                                  !Ǯ [J/K kg]
  public xz_LatentHeatPerMol, LatentHeatPerMol
                                                  !Ǯ [J/K mol]
  public LatentHeatPerMolAMP
                                                  !Ǯ [J/K mol]
  public ReactHeatNH4SHPerMass, ReactHeatNH4SHPerMol
                                                  !NH4SH ȿǮ

  real(8)             :: ReactHeatNH4SHPerMass    !NH4SH ȿǮ [J/K kg]
  real(8)             :: ReactHeatNH4SHPerMol     !NH4SH ȿǮ [J/K mol]
  integer             :: XMin = 10   !X ɸϰ(). ͤϥߡ
  integer             :: XMax = 10   !X ɸϰ(). ͤϥߡ
  integer             :: ZMin = 10   !Z ɸϰ(). ͤϥߡ
  integer             :: ZMax = 10   !Z ɸϰ(). ͤϥߡ
  integer             :: SpcNum = 1  !ؼο. ͤϥߡ
  real(8)             :: a_AntA(ChemData_SpcNum)   !Antoine ξ A 
  real(8)             :: a_AntB(ChemData_SpcNum)   !Antoine ξ B 
  real(8)             :: a_AntC(ChemData_SpcNum)   !Antoine ξ C 
  real(8)             :: a_AntU(ChemData_SpcNum)   !Antoine ξñ̴Τη
  real(8)             :: a_MolWt(ChemData_SpcNum)  !ʬ
  integer, allocatable      :: SpcID(:)     !Ϥ˴ޤޤ벽ؼ. Ƚ
  character(3), allocatable :: Phase(:)     !
 
  save ReactHeatNH4SHPerMass, ReactHeatNH4SHPerMol
  save XMin, XMax, ZMin, ZMax, SpcNum
  save SpcID, Phase
  save a_AntA, a_AntB, a_AntC, a_AntU, a_MolWt

contains
  
!!!
!!! 롼
!!!
!!!==========================================================================
  subroutine ChemCalc_Init(IMin, IMax, KMin, KMax, SNum, SID)
    !
    !롼Υåѡ. 
    !  ChemCalcSpc_init  ChemCalcDim_init ¹
    !

    !⥸塼ƤӽФ
    use ChemData, only: GasRUniv,      &!
      &                 ChemData_SpcID  !ؼ ID 
      
    !ۤηػ
    implicit none

    !ѿ
    integer,intent(in) :: IMin      !X β
    integer,intent(in) :: IMax      !X ξ
    integer,intent(in) :: KMin      !Z β
    integer,intent(in) :: KMax      !Z ξ
    integer,intent(in) :: SNum      !ؼθĿ
    integer,intent(in) :: SID(SNum) !Ϥ¸ߤ벽ؼο
    character(20)      :: Name(1)
    integer            :: dim
    integer            :: id(1)

    !롼 2 ĸƤӽФ
    call ChemCalcSpc_Init(SNum, SID)
    call ChemCalcDim_Init(IMin, IMax, KMin, KMax)


    !NH4SH ȿǮν
    !  NH4SH 1kg ФȿǮˤ.
    dim     = 1
    Name(1) = 'NH4SH-s'
    id      = ChemData_SpcID(dim, Name) 
    
    ReactHeatNH4SHPerMol  = GasRUniv * 10834.0d0
    ReactHeatNH4SHPerMass = GasRUniv * 10834.0d0 / MolWt( id(1) )

  end subroutine ChemCalc_Init


!!!==========================================================================
  subroutine ChemCalcSpc_Init(SNum, SID)
    !
    !롼( 1). 
    !  Ѥ벽ؼγ, 줾ʪͤꤹ.
    !  ׻򤷤ʤˤ, ν򤹤нʬǤ. 
    !

    !⥸塼ƤӽФ
    use ChemData, only: ChemData_Phase    !

    !ۤηػ
    implicit none

    !ѿ
    integer,intent(in) :: SNum            !ؼθĿ
    integer,intent(in) :: SID(SNum)       !Ϥ¸ߤ벽ؼο
    
    !ѿ
    integer            :: s

    !-----------------------------------------------------------
    ! 
    !-----------------------------------------------------------
    SpcNum  = SNum
!    write(*,*) "ChemCalc: SpcNum ", SpcNum
    
    !
    if (allocated(SpcID)) deallocate( SpcID, Phase)
    allocate( SpcID(SpcNum),  Phase(SpcNum) )

    !-----------------------------------------------------------    
    ! ǡ١ɬפʥǡФ
    !-----------------------------------------------------------
    !Ϥ¸ߤ벽ؼ. Ϥ줿ͤ
    SpcID = SID
    
    !
    do s = 1, SpcNum
      Phase(s) = ChemData_Phase(SpcID(s)) 
    end do
    
    !Antoine ˰¾η
    a_AntA = ChemData_SvapPress_AntoineA
    a_AntB = ChemData_SvapPress_AntoineB
    a_AntC = ChemData_SvapPress_AntoineC
    a_AntU = ChemData_SvapPress_AntoineUnit

    !ʬ
    a_MolWt = ChemData_MolWt
    
  end subroutine ChemCalcSpc_Init


!!!==========================================================================
  subroutine ChemCalcDim_Init(IMin, IMax, KMin, KMax)
    !
    !롼( 2)
    !  󥵥γԤ. ؿѤˤ, 
    !  Υ֥롼ǽɬפ. 
    !   ChemCalcSpc_init ¹ԤƤɬפ. 
    !

    !ۤηػ
    implicit none

    !ѿ
    integer,intent(in) :: IMin  !X β
    integer,intent(in) :: IMax  !X ξ
    integer,intent(in) :: KMin  !Z β
    integer,intent(in) :: KMax  !Z ξ
    
    !-----------------------------------------------------------
    ! 
    !-----------------------------------------------------------
    XMin = IMin;    XMax = IMax
    ZMin = KMin;    ZMax = KMax
    
  end subroutine ChemCalcDim_Init


!!!
!!! ˰¾, Ǯ, etc. δܴؿ. 
!!! ؼ ID Ȳ٤Ф֤ͤ
!!!  

!!!==========================================================================
  function EntropyNH4SH(ID_NH3, ID_H2S, Temp)
    !
    !NH4SH ɸಽإݥƥ󥷥׻. 
    !
    
    !⥸塼ƤӽФ
    use ChemData, only: PressRef,            &!వ
      &                 GasRUniv              !
      
    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: EntropyNH4SH       !ɸಽإݥƥ󥷥
    real(8), intent(in) :: Temp               !
    integer, intent(in) :: ID_NH3             !˥ ID
    integer, intent(in) :: ID_H2S             !βǤ ID

    EntropyNH4SH = 0.0d0
    EntropyNH4SH = &
      &   EntropyRef(ID_NH3, Temp) &
      & + EntropyRef(ID_H2S, Temp) &
      & - GasRUniv * 61.781d0            &
      & + GasRUniv * dlog( PressRef * PressRef * 1.0d2) 

  end function EntropyNH4SH


!!!==========================================================================
  function EntropyRef(ID, Temp)
    !
    !Ϳ줿ؼФ, ɸಽإݥƥ󥷥׻.
    !
    
    !⥸塼ƤӽФ
    use ChemData, only: ChemData_CpPerMolRef,&!ɸ֤Ǥñ̥Ǯ
      &                 ChemData_Entropy,    &!ɸ֤ǤΥȥԡ
      &                 TempRef               !ಹ
      
    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: EntropyRef         !ɸಽإݥƥ󥷥
    real(8), intent(in) :: Temp               !
    integer, intent(in) :: ID           !ؼ ID
    real(8)             :: CpPerMol           !Ǯ 
    real(8)             :: Entropy            !ȥԡ
    real(8)             :: sign               !ʬΤ
    
    !ǡ١
    CpPerMol = ChemData_CpPerMolRef(ID)
    Entropy  = ChemData_Entropy(ID)
    
    EntropyRef = 0.0d0
    sign = 1.0d0
    if (Temp < TempRef) sign = -1.0d0

    EntropyRef =                &
      &   Temp * Entropy              &
      & + sign * CpPerMol * dlog( (Temp / TempRef) ** sign )
    
  end function EntropyRef


!!!==========================================================================
  function Entropy(ID, Temp, PPress)
    !
    !Ϳ줿ؼФ, إݥƥ󥷥׻.
    !
    
    !⥸塼ƤӽФ
    use ChemData, only: PressRef,           & !వ
      &                 GasRUniv              !
    
    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: Entropy            !ɸಽإݥƥ󥷥
    real(8), intent(in) :: Temp               !
    real(8), intent(in) :: PPress             !
    integer, intent(in) :: ID           !ؼ ID
    
    Entropy = 0.0d0
    
    Entropy = &
      & EntropyRef(ID, Temp) - GasRUniv * dlog(PPress / PressRef)
    
  end function Entropy
  

!!!==========================================================================
  function ChemPotNH4SH(ID_NH3, ID_H2S, Temp)
    !
    !NH4SH ɸಽإݥƥ󥷥׻. 
    !
    
    !⥸塼ƤӽФ
    use ChemData, only: PressRef,            &!వ
      &                 GasRUniv              !
      
    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: ChemPotNH4SH       !ɸಽإݥƥ󥷥
    real(8), intent(in) :: Temp               !
    integer, intent(in) :: ID_NH3             !˥ ID
    integer, intent(in) :: ID_H2S             !βǤ ID

    ChemPotNH4SH = 0.0d0
    ChemPotNH4SH = &
      &   ChemPotRef(ID_NH3, Temp) &
      & + ChemPotRef(ID_H2S, Temp) &
      & + GasRUniv * Temp * 61.781d0 - GasRUniv * 10834.0d0  &
      & - GasRUniv * Temp * dlog( PressRef * PressRef * 1.0d2) 

  end function ChemPotNH4SH


!!!==========================================================================
  function ChemPotRef(ID, Temp)
    !
    !Ϳ줿ؼФ, ɸಽإݥƥ󥷥׻.
    !
    
    !⥸塼ƤӽФ
    use ChemData, only: ChemData_CpPerMolRef,&!ɸ֤Ǥñ̥Ǯ
      &                 ChemData_Enthalpy,   &!ɸ֤ǤΥ󥿥ԡ
      &                 ChemData_Entropy,    &!ɸ֤ǤΥȥԡ
      &                 TempRef               !ಹ
      
    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: ChemPotRef         !ɸಽإݥƥ󥷥
    real(8), intent(in) :: Temp               !
    integer, intent(in) :: ID           !ؼ ID
    real(8)             :: CpPerMol           !Ǯ 
    real(8)             :: Enthalpy           !󥿥ԡ
    real(8)             :: Entropy            !ȥԡ
    real(8)             :: sign               !ʬΤ
    
    !ǡ١
    CpPerMol = ChemData_CpPerMolRef(ID)
    Enthalpy = ChemData_Enthalpy(ID)
    Entropy  = ChemData_Entropy(ID)
    
    ChemPotRef = 0.0d0
    sign = 1.0d0
    if (Temp < TempRef) sign = -1.0d0

    ChemPotRef =                &
      &   Enthalpy                    &
      & - Temp * Entropy              &
      & + CpPerMol * (Temp - TempRef) &
      & - sign * CpPerMol * Temp * dlog( (Temp / TempRef) ** sign )
    
  end function ChemPotRef


!!!==========================================================================
  function ChemPot(ID, Temp, PPress)
    !
    !Ϳ줿ؼФ, إݥƥ󥷥׻.
    !
    
    !⥸塼ƤӽФ
    use ChemData, only: PressRef,           & !వ
      &                 GasRUniv              !
    
    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: ChemPot            !ɸಽإݥƥ󥷥
    real(8), intent(in) :: Temp               !
    real(8), intent(in) :: PPress             !ؼʬ
    integer, intent(in) :: ID           !ؼ ID
    
    ChemPot = 0.0d0
    
    ChemPot = &
      & ChemPotRef(ID, Temp) &
      & + GasRUniv * Temp * dlog( PPress / PressRef)
    
  end function ChemPot
  

!!!==========================================================================
  function CpPerMassRef(ID)
    !
    !Ϳ줿ؼФ, ɸ֤Ǥñ̼갵Ǯ׻
    !

    !⥸塼ƤӽФ
    use ChemData, only: ChemData_CpPerMassRef !ɸ֤Ǥñ̼Ǯ

    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: CpPerMassRef       !ɸ֤Ǥñ̼Ǯ
    integer, intent(in) :: ID           !ؼ ID

    
    !ǡ١
    CpPerMassRef = ChemData_CpPerMassRef(ID)

  end function CpPerMassRef


!!!==========================================================================
  function CpPerMolRef(ID)
    !
    !Ϳ줿ؼФ, ɸ֤Ǥñ̼갵Ǯ׻
    !

    !⥸塼ƤӽФ
    use ChemData, only: ChemData_CpPerMolRef !ɸ֤Ǥñ̼Ǯ

    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: CpPerMolRef        !ɸ֤Ǥñ̼Ǯ
    integer, intent(in) :: ID           !ؼ ID

    
    !ǡ١
    CpPerMolRef = ChemData_CpPerMolRef(ID)

  end function CpPerMolRef


!!!==========================================================================
  function CvPerMassRef(ID)
    !
    !Ϳ줿ؼФ, ɸ֤Ǥñ̼갵Ǯ׻
    !

    !⥸塼ƤӽФ
    use ChemData, only: ChemData_CvPerMassRef !ɸ֤Ǥñ̼Ǯ

    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: CvPerMassRef       !ɸ֤Ǥñ̼Ǯ
    integer, intent(in) :: ID           !ؼ ID

    
    !ǡ١
    CvPerMassRef = ChemData_CvPerMassRef(ID)

  end function CvPerMassRef


!!!==========================================================================
  function MolWt(ID)
    !
    !Ϳ줿ؼФ, ʬ̤׻
    !

    !⥸塼ƤӽФ
    use ChemData, only: ChemData_MolWt   !ʬ

    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: MolWt         !ʬ
    integer, intent(in) :: ID      !ؼ ID

    
    !ǡ١
    MolWt = ChemData_MolWt(ID)

  end function MolWt


!!!==========================================================================
  function GasR(ID)
    !
    !Ϳ줿ؼФ, ׻
    !

    !⥸塼ƤӽФ
    use ChemData, only: ChemData_GasR    ! [J/K kg]

    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: GasR          !ʬ
    integer, intent(in) :: ID      !ؼ ID
    
    
    !ǡ١
    GasR = ChemData_GasR(ID)

  end function GasR


!!!==========================================================================
  function SvapPressAMP(ID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, ˰¾׻. AMP 
    !

    !⥸塼ƤӽФ
    use ChemData, only:                          &
      &                 ChemData_SvapPress_AMPA, & !AMP  A 
      &                 ChemData_SvapPress_AMPB, & !AMP  B 
      &                 ChemData_SvapPress_AMPC, & !AMP  C 
      &                 ChemData_SvapPress_AMPD, & !AMP  D 
      &                 ChemData_SvapPress_AMPE    !AMP  E 

    !ۤηػ
    implicit none
    
    !ѿ  
    real(8)             :: SvapPressAMP          !˰¾
    integer, intent(in) :: ID              !ؼ ID
    real(8), intent(in) :: Temp                  ! [K]

    !ѿ
    real(8)             :: A, B, C, D, E
    real(8)             :: LogSvapPress
    
    !
    SvapPressAMP = 0.0d0
    A = ChemData_SvapPress_AMPA(ID)
    B = ChemData_SvapPress_AMPB(ID)
    C = ChemData_SvapPress_AMPC(ID)
    D = ChemData_SvapPress_AMPD(ID)
    E = ChemData_SvapPress_AMPE(ID)
    
    !˰¾п׻
    LogSvapPress =  A / Temp + B + C * dlog(Temp) + D * Temp &
      &             + E * (temp ** 2) + dlog(1.0d-1) 
    
    !п礭ʤꤹʤ褦ˤ. 
    ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
    LogSvapPress = min(7.0d2, LogSvapPress)

    !˰¾׻
    SvapPressAMP =  dexp( LogSvapPress )
    
  end function SvapPressAMP


!!!==========================================================================
  function DLogSvapPressAMPDTemp(ID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, ˰¾ log βʬ׻
    !AMP 
    !
    
    !⥸塼ƤӽФ
    use ChemData, only:                          & !
      &                 ChemData_SvapPress_AMPA, & !Antoine  B 
      &                 ChemData_SvapPress_AMPC, & !Antoine  B 
      &                 ChemData_SvapPress_AMPD, & !Antoine  B 
      &                 ChemData_SvapPress_AMPE    !Antoine  C 
    
    !ۤηػ
    implicit none
  
    !ѿ    
    real(8)             :: DLogSvapPressAMPDTemp 
                                            !˰¾ log βʬ [Pa/K]
    integer, intent(in) :: ID         !ؼ ID
    real(8), intent(in) :: Temp             ! [K]
    
    !ѿ
    real(8)             :: A, C, D, E
    
    !
    DLogSvapPressAMPDTemp = 0.0d0
    A = ChemData_SvapPress_AMPA(ID)
    C = ChemData_SvapPress_AMPC(ID)
    D = ChemData_SvapPress_AMPD(ID)
    E = ChemData_SvapPress_AMPE(ID)
    
    !˰¾βʬ
    DLogSvapPressAMPDTemp =                                 &
      & - A / (Temp ** 2.0d0) + C / Temp + D + (2.0d0 * E * Temp)
    
  end function DLogSvapPressAMPDTemp


!!!==========================================================================
  function DSvapPressAMPDTemp(ID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, ˰¾βʬ׻
    !
    
    !ۤηػ
    implicit none
  
    !ѿ    
    real(8)             :: DSvapPressAMPDTemp  
                                                  !˰¾βʬ [Pa/K]
    integer, intent(in) :: ID               !ؼ̾
    real(8), intent(in) :: Temp                   ! [K]
    
    !
    DSvapPressAMPDTemp = 0.0d0
    
    !˰¾βʬ
    DSvapPressAMPDTemp =                          &
      & SvapPressAMP(ID, Temp)              &
      & * DLogSvapPressAMPDTemp(ID, Temp)
    
  end function DSvapPressAMPDTemp
  

!!!==========================================================================
  function LatentHeatPerMassAMP(ID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, Ǯ׻
    !

    !⥸塼ƤӽФ
    use ChemData, only: ChemData_MolWt         !ʬ

    !ۤηػ
    implicit none

    !ѿ
    real(8)             :: LatentHeatPerMassAMP !Ǯ
    integer, intent(in) :: ID            !ؼ̾
    real(8), intent(in) :: Temp                !
    
    !ѿ
    real(8), parameter  :: GasRUniv = 8.314d0  !׵
    
    !
    LatentHeatPerMassAMP  = 0.0d0
    
    !Ǯη׻
    LatentHeatPerMassAMP =                           &
      & DLogSvapPressAMPDTemp(ID, Temp) &
      & * GasRUniv * (Temp ** 2.0d0)                &
      & / ChemData_MolWt(ID)

  end function LatentHeatPerMassAMP


!!!==========================================================================
  function LatentHeatPerMolAMP(ID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, Ǯ׻
    !

     !ۤηػ
    implicit none

    !ѿ
    real(8)             :: LatentHeatPerMolAMP !Ǯ
    integer, intent(in) :: ID            !ؼ̾
    real(8), intent(in) :: Temp                !
    
    !ѿ
    real(8), parameter  :: GasRUniv = 8.314d0  !׵
    
    !
    LatentHeatPerMolAMP  = 0.0d0
    
    !Ǯη׻
    LatentHeatPerMolAMP =                           &
      & DLogSvapPressAMPDTemp(ID, Temp)       &
      & * GasRUniv * (Temp ** 2.0d0)                

  end function LatentHeatPerMolAMP



!!!==========================================================================
  function SvapPress(ID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, ˰¾׻
    !

    !ۤηػ
    implicit none
    
    !ѿ   
    real(8)             :: SvapPress          !˰¾
    integer, intent(in) :: ID           !ؼ ID
    real(8), intent(in) :: Temp               ! [K]

    !ѿ
    real(8)             :: LogSvapPress
    real(8), parameter  :: Temp0C = 273.15d0
    
    !˰¾п׻
    LogSvapPress =                                     &
      & (                                              &
      &    a_AntA(ID)                                  &
      &    - a_AntB(ID) / (a_AntC(ID) + Temp - Temp0C) &
      &  ) * dlog(10.0d0)                              &
      & + a_AntU(ID)

    !п礭ʤꤹʤ褦ˤ. 
    ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
    LogSvapPress = min(7.0d2, LogSvapPress)
    
    !˰¾׻
    SvapPress =  dexp( LogSvapPress )

  end function SvapPress


!!!==========================================================================
  function DSvapPressDTemp(ID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, ˰¾βʬ׻
    !
    
    !ۤηػ
    implicit none
  
    !ѿ    
    real(8)             :: DSvapPressDTemp        !˰¾βʬ [Pa/K]
    integer, intent(in) :: ID                     !ؼ̾
    real(8), intent(in) :: Temp                   ! [K]

    !ѿ
    real(8)             :: LogSvapPress
    real(8)             :: DLogSvapPressDTemp
    real(8), parameter  :: Temp0C = 273.15d0
    

    !˰¾п׻
    LogSvapPress =                                     &
      & (                                              &
      &    a_AntA(ID)                                  &
      &    - a_AntB(ID) / (a_AntC(ID) + Temp - Temp0C) &
      &  ) * dlog(10.0d0)                              &
      & + a_AntU(ID)

    DLogSvapPressDTemp =                               &
      &  a_AntB(ID) * dlog(10.0d0)                     &
      &   / ( (a_AntC(ID) + Temp - Temp0C) ** 2.0d0 )
    
    !п礭ʤꤹʤ褦ˤ. 
    ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
    LogSvapPress = min(7.0d2, LogSvapPress)
    
    !˰¾βʬ
    DSvapPressDTemp = dexp( LogSvapPress ) * DLogSvapPressDTemp
    
  end function DSvapPressDTemp


!!!==========================================================================
  function LatentHeatPerMass(ID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, Ǯ׻
    !

    !ۤηػ
    implicit none

    !ѿ
    real(8)             :: LatentHeatPerMass   !Ǯ
    integer, intent(in) :: ID                  !ؼ̾
    real(8), intent(in) :: Temp                !

    !ؿ
    real(8)             :: DLogSvapPressDTemp
    real(8), parameter  :: GasRUniv = 8.314d0  !׵
    real(8), parameter  :: Temp0C = 273.15d0

    
    !Ǯη׻
    DLogSvapPressDTemp =                               &
      &  a_AntB(ID) * dlog(10.0d0)                     &
      &   / ( (a_AntC(ID) + Temp - Temp0C) ** 2.0d0 )

    LatentHeatPerMass =                                 &
      & DLogSvapPressDTemp * GasRUniv * (Temp ** 2.0d0) &
      & / MolWt(ID)

  end function LatentHeatPerMass


!!!==========================================================================
  function LatentHeatPerMol(ID, Temp)
    !
    !Ϳ줿ؼȲ٤Ф, Ǯ׻
    !

    !ۤηػ
    implicit none

    !ѿ
    real(8)             :: LatentHeatPerMol    !Ǯ
    integer, intent(in) :: ID                  !ؼ̾
    real(8), intent(in) :: Temp                !

    !ؿ
    real(8)             :: DLogSvapPressDTemp
    real(8), parameter  :: GasRUniv = 8.314d0  !׵
    real(8), parameter  :: Temp0C = 273.15d0

    
    !Ǯη׻
    DLogSvapPressDTemp =                               &
      &  a_AntB(ID) * dlog(10.0d0)                     &
      &   / ( (a_AntC(ID) + Temp - Temp0C) ** 2.0d0 )

    LatentHeatPerMol =                                &
      & DLogSvapPressDTemp * GasRUniv * (Temp ** 2.0d0) 

!    write(*,*) 'LatentHeatPerMol ', ID, Temp, LatentHeatPerMol

  end function LatentHeatPerMol


!!!
!!! ˰¾å롼
!!!

!!!==========================================================================
  subroutine CheckSvapPress()
    !
    !˰¾Υå֥롼. 
    !¬ͤȷ׻ͤκϤ.
    !

    !⥸塼ɤ߹
    use ChemData, only : ChemData_DataNum,         & !ǡ 
      &                  ChemData_SVapPress,       & !˰¾
      &                  ChemData_SVapPress_Temp     !
    
    !ۤηػ
    implicit none
    
    !ѿ
    integer             :: SNum
    integer             :: DNum
    real(8)             :: SVapPressData(SpcNum, ChemData_DataNum)
    real(8)             :: Temp(SpcNum, ChemData_DataNum)
    real(8)             :: SVapPressCalc

    !ǡ١
    do SNum = 1, SpcNum
      SvapPressData(SNum,:) = ChemData_SvapPress(SpcID(SNum),:) 
      Temp(SNum,:)          = ChemData_SvapPress_Temp(SpcID(SNum),:) 
    end do

    do SNum = 1, SpcNum
      if (Phase(SNum) == 'Gas') cycle   !ξ
      
      write(*,*) "SpcName:      ", SpcID(SNum)
      
      do DNum = 1, ChemData_DataNum
        if ( Temp(SNum,DNum) == 0.0d0) cycle
        SvapPressCalc = SvapPress( SpcID(SNum), Temp(SNum,DNum) )
        
        write(*,*) "Temp:         ", Temp(SNum,DNum)
        write(*,*) "SVapPress:    ", SVapPressData(SNum,DNum), SVapPressCalc
        write(*,*) "DelSVapPress: ", abs(SVapPressData(SNum,DNum) - SVapPressCalc)
      end do
      SVapPressCalc = 0.0d0 !
    end do
    
  end subroutine CheckSvapPress
  

!!!
!!!  2 δؿ
!!!

!!!==========================================================================
  function xz_SvapPress( ID, xz_Temp )
    !
    !˰¾η׻. Antoine μ
    !

    !ۤηػ
    implicit none
    
    ! ѿ  
    real(8)             :: xz_SvapPress(XMin:XMax, ZMin:ZMax) 
                                                          !˰¾
    real(8), intent(in) :: xz_Temp(XMin:XMax, ZMin:ZMax)  !
    integer, intent(in) :: ID                             !ؼ ID
  
    !ѿ
    real(8)             :: xz_LogSvapPress(XMin:XMax, ZMin:ZMax) 
    real(8), parameter  :: Temp0C = 273.15d0


    !˰¾ log ׻
    !п礭ʤꤹʤ褦ˤ. 
    ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
    xz_LogSvapPress =                                          &
      & min(                                                   & 
      &       (                                                &
      &         a_AntA(ID)                                     &
      &         - a_AntB(ID) / (a_AntC(ID) + xz_Temp - Temp0C) &
      &        ) * dlog(10.0d0)                                &
      &        + a_AntU(ID),                                   &
      &      7.0d2                                             &
      &    )
    
    !˰¾׻
    xz_SvapPress =  dexp( xz_LogSvapPress )

  end function xz_SvapPress


!!!==========================================================================
  function xz_DSvapPressDTemp(ID, xz_Temp)
    !
    !˰¾βʬη׻. Antoine μ
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8)             :: xz_DSvapPressDTemp(XMin:XMax, ZMin:ZMax)
                                                  !˰¾βʬ [Pa/K]
    real(8), intent(in) :: xz_Temp(XMin:XMax, ZMin:ZMax)           
                                                  ! [K]
    integer, intent(in) :: ID                     !ؼ ID
  
    !ѿ
    real(8)             :: xz_LogSvapPress(XMin:XMax, ZMin:ZMax)
    real(8)             :: xz_DLogSvapPressDTemp(XMin:XMax, ZMin:ZMax)
    real(8), parameter  :: Temp0C = 273.15d0


    !˰¾ log ׻
    !п礭ʤꤹʤ褦ˤ. 
    ! Fujitsu Fortran Compiler Ǥ 700 礭 exp ȷٹ𤬽Ф.
    xz_LogSvapPress =                                          &
      & min(                                                   &
      &      (                                                 &
      &          a_AntA(ID)                                    &
      &        - a_AntB(ID) / (a_AntC(ID) + xz_Temp - Temp0C)  &
      &       ) * dlog(10.0d0)                                 &
      &       + a_AntU(ID),                                    &
      &     7.0d2                                              &
      &    )
    
    xz_DLogSvapPressDTemp =                                &
      & a_AntB(ID) * dlog(10.0d0)                          &
      &  / ( (a_AntC(ID) + xz_Temp - Temp0C) ** 2.0d0 )
    
    !˰¾βʬ׻
    xz_DSvapPressDTemp = dexp( xz_LogSvapPress ) * xz_DLogSvapPressDTemp
    
  end function xz_DSvapPressDTemp
  

!!!==========================================================================
  function xz_LatentHeatPerMol(ID, xz_Temp)
    !
    !˰¾Ǯ׻. Antoine μ
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8)             :: xz_LatentHeatPerMol(XMin:XMax, ZMin:ZMax)
                                                            !Ǯ[J/K kg]
    real(8), intent(in) :: xz_Temp(XMin:XMax, ZMin:ZMax)    ![K]
    integer, intent(in) :: ID                               !ؼ ID

    !ؿ
    real(8)             :: xz_DLogSvapPressDTemp(XMin:XMax, ZMin:ZMax)
    real(8), parameter  :: GasRUniv = 8.314d0
    real(8), parameter  :: Temp0C = 273.15d0


    !˰¾ log ׻, Ǯ׻. 
    xz_DLogSvapPressDTemp =                                    &
      & a_AntB(ID) * dlog(10.0d0)                              &
      &  / ( (a_AntC(ID) + xz_Temp - Temp0C) ** 2.0d0 )
    
    xz_LatentHeatPerMol =                                      &
      & xz_DLogSvapPressDTemp * GasRUniv * (xz_Temp ** 2.0d0) 
    
  end function xz_LatentHeatPerMol


!!!==========================================================================
  function xz_LatentHeatPerMass(ID, xz_Temp)
    !
    !˰¾Ǯ׻. Antoine μ
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8)             :: xz_LatentHeatPerMass(XMin:XMax, ZMin:ZMax)
                                                            !Ǯ[J/K kg]
    real(8), intent(in) :: xz_Temp(XMin:XMax, ZMin:ZMax)    ![K]
    integer, intent(in) :: ID                       !ؼ ID

    !ؿ
    real(8)             :: xz_DLogSvapPressDTemp(XMin:XMax, ZMin:ZMax)
    real(8), parameter  :: GasRUniv = 8.314d0
    real(8), parameter  :: Temp0C = 273.15d0

    !
    xz_DLogSvapPressDTemp = 0.0d0
    xz_LatentHeatPerMass  = 0.0d0

    !˰¾ log ׻, Ǯ׻. 
    xz_DLogSvapPressDTemp =                                   &
      & a_AntB(ID) * dlog(10.0d0)                             &
      &  / ( (a_AntC(ID) + xz_Temp - Temp0C) ** 2.0d0 )
    
    xz_LatentHeatPerMass =                                    &
      & xz_DLogSvapPressDTemp * GasRUniv * (xz_Temp ** 2.0d0) &
      &  / a_MolWt(ID)

  end function xz_LatentHeatPerMass

end module ChemCalc

