!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2006. All rights reserved.
!---------------------------------------------------------------------
!= Module MoistBuoyancy
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: moistbuoyancy.f90,v 1.3 2006/06/27 01:51:11 sugiyama Exp $
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview
!
!
!== Error Handling
!
!== Bugs
!
!== Note
!
!
!== Future Plans
!
!

module MoistBuoyancy
  !
  !
  !

  !⥸塼ɤ߹ 
  use gridset, only:  SpcNum,            &! ؼο
    &                 DimXMin,           &! x β
    &                 DimXMax,           &! x ξ
    &                 DimZMin,           &! z β
    &                 DimZMax,           &! z ξ
    &                 DelX,              &! x γʻֳ
    &                 DelZ                ! z γʻֳ
  use basicset, only: MolWtDry,          &!ʬʬ
    &                 Grav,              &!ϲ®
    &                 SpcWetSymbol,      &!Žʬ̾
    &                 MolWtWet,          &!Žʬʬ
    &                 xza_MixRtBasicZ      !ܾκ
  use ChemCalc, only: xz_LatentHeatPerMass       !Ǯ
  use ChemData, only: ChemData_OneSpcID
  use average,  only: xr_avr_xz, xz_avr_xr
  use differentiate_center4, only: xr_dz_xz

  !ۤηػ
  implicit none
  
  !°λ
  private
  
  !ؿ public 
  public MoistBuoy_Init
!  public xz_MoistBuoyKm
  public xr_BuoyMolWt
  public xr_BuoyLoad

  !ѿ
  integer     :: LoopNum      = 0
  integer     :: GasNum(10)   = 0
  integer     :: CloudNum(10) = 0
  real(8)     :: Cm           = 2.0d-1
  real(8)     :: MixLen       = 0.0d0
  real(8), allocatable :: xr_MixRtBasicZPerMolWt(:,:)
                              !ܾκ / ʬ 
  real(8), allocatable :: xr_MixRtBasicZ(:,:)
                              !ܾκ
  
  save GasNum, CloudNum, LoopNum
  save Cm, MixLen
  save xr_MixRtBasicZPerMolWt
  save xr_MixRtBasicZ

contains

!!!------------------------------------------------------------------!!!
  subroutine MoistBuoy_Init( )

    !ۤηػ
    implicit none

    !ѿ
    integer              :: s
    integer              :: n1
    real(8), allocatable :: xza_MixRtBasicZPerMolWt(:,:,:)
                                  !ܾκ / ʬ

    !-----------------------------------------------------------
    ! Υ
    !-----------------------------------------------------------
    MixLen = sqrt(DelX * DelZ) 
    
    !-----------------------------------------------------------
    ! γȵΤ ID Ȥ
    !-----------------------------------------------------------
    !ؼ椫γΤ, źʬ̤ݴ.
    LoopNum = 0
    SelectCloud: do s = 1, SpcNum
      
!      !'Cloud' Ȥʸ󤬴ޤޤΤθĿ
!      n1 = index(SpcWetSymbol(s), '-Cloud' )
!      if (n1 /= 0) then
!        LoopNum          = LoopNum + 1
!        CloudNum(LoopNum)= s
!        GasNum(LoopNum)  = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID(SpcWetSymbol(s)(1:n1-3) // '-g'))
!      end if

      !'-g' Ȥʸ󤬴ޤޤΤθĿ
      n1 = index(SpcWetSymbol(s), '-g' )
      if (n1 /= 0) then
        LoopNum          = LoopNum + 1
!        CloudNum(LoopNum)= s
        GasNum(LoopNum)  = s
      end if
    end do SelectCloud
    
    !-----------------------------------------------------------
    ! ν. 
    !-----------------------------------------------------------
    allocate( &
      & xza_MixRtBasicZPerMolWt(DimXMin:DimXMax, DimZMin:DimZMax, LoopNum), &
      & xr_MixRtBasicZPerMolWt(DimXMin:DimXMax, DimZMin:DimZMax),           &
      & xr_MixRtBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)                    &
      & )

    do s = 1, LoopNum
      xza_MixRtBasicZPerMolWt(:,:,GasNum(s)) = &
        & xza_MixRtBasicZ(:,:,GasNum(s)) / MolWtWet(GasNum(s))
    end do
    xr_MixRtBasicZPerMolWt = xr_avr_xz( sum(xza_MixRtBasicZPerMolWt, 3) )
    xr_MixRtBasicZ         = xr_avr_xz( sum(xza_MixRtBasicZ, 3) ) 
    
    !-----------------------------------------------------------
    ! ǧ
    !-----------------------------------------------------------
    write(*,*) "MoistAdjust_Init, LoopNum:  ", LoopNum
!    write(*,*) "MoistAdjust_Init, CloudNum: ", CloudNum
    write(*,*) "MoistAdjust_Init, GasNum:   ", GasNum    

  end subroutine MoistBuoy_Init


!!!------------------------------------------------------------------------!!!
  function xr_BuoyMolWt(xza_MixRt)
    !
    ! ľαư˸ϹΤ, 
    ! ʬ̤θ̤
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)  :: xza_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                               !Žʬκ
    real(8)              :: xr_BuoyMolWt(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !Ϲ(ʬ̸)
    real(8)              :: xza_MixRtPerMolWt(DimXMin:DimXMax, DimZMin:DimZMax, LoopNum)
                                               !/ʬ
    integer              :: s
    
    !
    xr_BuoyMolWt           = 0.0d0

    !ν. ΤΤ
    do s = 1, LoopNum
      xza_MixRtPerMolWt(:,:,GasNum(s)) = xza_MixRt(:,:,GasNum(s)) / MolWtWet(GasNum(s))
    end do
    
    !Ϲη׻
    xr_BuoyMolWt =                                             &
      & + Grav * xr_avr_xz( sum(xza_MixRtPerMolWt, 3) )        &
      &    / ( 1.0d0 / MolWtDry + xr_MixRtBasicZPerMolWt )     &
      & - Grav * xr_avr_xz( sum(xza_MixRt(:,:,1:LoopNum), 3) ) &
      &    / ( 1.0d0 + xr_MixRtBasicZ )

  end function xr_BuoyMolWt


!!!------------------------------------------------------------------------!!!
  function xr_BuoyLoad(xza_MixRt)
    !
    ! ľαư˸ϹΤ, 
    ! ʬ̤θ̤
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)  :: xza_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                               !Žʬκ
    real(8)              :: xr_BuoyLoad(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !Ϲ(ʬ̸)
    !
    xr_BuoyLoad           = 0.0d0

    !Ϲη׻
    xr_BuoyLoad =                                                     &
      & - Grav * xr_avr_xz( sum(xza_MixRt(:,:,LoopNum+1:SpcNum), 3) ) &
      &    / ( 1.0d0 + xr_MixRtBasicZ )

  end function xr_BuoyLoad

  
end module MoistBuoyancy
